import numpy as np
import fractions
from fractions import Fraction
class GaussMethod:
    def __init__(self, A, out):
        self.m = A.shape[0]
        self.A = A.astype(int)
        self.out = out

    def solve(self):
        C = np.copy(self.A)
        print >> self.out, "== FORWARD PHASE"
        print >> self.out, "C1:"
        print >> self.out, C
        C = self.straight_step(1, C)
        for i in range(2, self.m):
            C = self.straight_step(i, C)
            print >> self.out, "REDUCE:"
            for j in range(i, self.m):
                self.reduction(i, j, C[i - 2, i - 2], C)
        det_A = C[self.m - 1, self.m - 1]
        dets = [C[self.m - 1, self.m]]
        print >> self.out, "\n\ndet(A) = %s" %(det_A, )
        print >> self.out, "det(%sA) = %s\n\n" % (self.m, dets[0], )
        print >> self.out, "== BACKWARD PHASE"
        for i in range(0, self.m - 1):
             dets.append(self.forward_step(self.m - 2 - i,dets, det_A, C))
             print >> self.out, "det(%sA) = %s" %(self.m - 1 - i, dets[len(dets) - 1])

        x = list(reversed([(self.m - i - 1, Fraction(dets[i], det_A)) for i in range(0, len(dets))]))

        print >> self.out, "\n\n== RESULT"
        for i in range(0, len(x)):
            print >> self.out, "x%s = %s" % (i + 1, x[i][1])
            
    def forward_step(self, k, dets, det_A, C):
        return (det_A * C[k, self.m] - sum([dets[d] * C[k, self.m - d - 1] for d in range(0, len(dets))])) / C[k, k]

    def straight_step(self, k, C):
        print >> self.out, "\n\nIteration %s." % (k, )
        C0 = np.copy(C)
        for i in range(k, self.m):
            print >> self.out, "Line %s:" % (i + 1, ), C0[i, :], '*', C[k - 1, k - 1], '-', C[k - 1, :], '*', C[i, k - 1]
            for j in range(0, self.m + 1):
                C0[i, j] = C[i, j] * C[k - 1, k - 1] - C[k - 1, j] * C[i, k - 1]
        print >> self.out, "C%s:" % (k + 1, )
        print >> self.out, C0
        return C0

    def reduction(self, k, j, el, C):
        print >> self.out, C[j, :], "by", el
        for i in range(k, self.m + 1):
            C[j, i] = C[j, i] / el                

def run_gauss(input_data, out):
    '''
    Runs extended gauss method
        :param input_data: parsed input data
        :param out: output stream (for log and solution printing)
    '''

    m = GaussMethod(np.matrix(input_data), out)
    m.solve()


	
