'''
Start point
'''
# system library
import sys
# present algorithms
import simplex_2_phase
import simplex_1_phase
import gauss
# reader of input data format
import file_reader
# parsing command-line arguments
from args import Controller, args
# RUN

controller = Controller(args)
method = controller.get_method()
if method == '2-phase':
    controller.run(simplex_2_phase.run_simplex, file_reader.read_input_data)
elif method == '1-phase':
    controller.run(simplex_1_phase.run_simplex, file_reader.read_input_data)
elif method == 'gauss':
    controller.run(gauss.run_gauss, file_reader.read_linear_system)
else:
    sys.exit('Method %s is not supported.' % method)

